import { __assign, __rest } from "tslib";
import { Type, ResizeType } from "../core-types";
import * as React from "react";
import { Space } from "./Space";
import * as PropTypes from "prop-types";
import { commonProps } from "../core-react";
export var Positioned = function (_a) {
    var left = _a.left, top = _a.top, right = _a.right, bottom = _a.bottom, width = _a.width, height = _a.height, resizable = _a.resizable, props = __rest(_a, ["left", "top", "right", "bottom", "width", "height", "resizable"]);
    var resizeTypes = resizable || [];
    return (React.createElement(Space, __assign({}, props, { type: Type.Positioned, position: {
            left: left,
            leftResizable: resizeTypes.includes(ResizeType.Left),
            top: top,
            topResizable: resizeTypes.includes(ResizeType.Top),
            right: right,
            rightResizable: resizeTypes.includes(ResizeType.Right),
            bottom: bottom,
            bottomResizable: resizeTypes.includes(ResizeType.Bottom),
            width: width,
            height: height,
        } }), props.children));
};
Positioned.propTypes = __assign(__assign({}, commonProps), {
    left: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    top: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    right: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    bottom: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    width: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    height: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    resizable: PropTypes.array,
});
//# sourceMappingURL=Positioned.js.map