import { __assign, __extends, __spreadArray } from "tslib";
import { CenterType, ResizeHandlePlacement, AnchorType, Type } from "../core-types";
import { useSpace, ParentContext, LayerContext, DOMRectContext, useEffectOnce } from "../core-react";
import * as React from "react";
import { Centered } from "./Centered";
import { CenteredVertically } from "./CenteredVertically";
import { shortuuid } from "../core-utils";
function applyCentering(children, centerType) {
    switch (centerType) {
        case CenterType.Vertical:
            return React.createElement(CenteredVertically, null, children);
        case CenterType.HorizontalVertical:
            return React.createElement(Centered, null, children);
    }
    return children;
}
var Space = /** @class */ (function (_super) {
    __extends(Space, _super);
    function Space() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Space.prototype.render = function () {
        return React.createElement(SpaceInner, __assign({}, this.props, { wrapperInstance: this }));
    };
    return Space;
}(React.Component));
export { Space };
var SpaceInner = function (props) {
    if (!props.id && !props.wrapperInstance["_react_spaces_uniqueid"]) {
        props.wrapperInstance["_react_spaces_uniqueid"] = "s".concat(shortuuid());
    }
    var style = props.style, className = props.className, onClick = props.onClick, onDoubleClick = props.onDoubleClick, onMouseDown = props.onMouseDown, onMouseEnter = props.onMouseEnter, onMouseLeave = props.onMouseLeave, onMouseMove = props.onMouseMove, onTouchStart = props.onTouchStart, onTouchMove = props.onTouchMove, onTouchEnd = props.onTouchEnd, children = props.children, handleRender = props.handleRender;
    var events = {
        onClick: onClick,
        onDoubleClick: onDoubleClick,
        onMouseDown: onMouseDown,
        onMouseEnter: onMouseEnter,
        onMouseLeave: onMouseLeave,
        onMouseMove: onMouseMove,
        onTouchStart: onTouchStart,
        onTouchMove: onTouchMove,
        onTouchEnd: onTouchEnd,
    };
    var _a = useSpace(__assign(__assign({}, props), { id: props.id || props.wrapperInstance["_react_spaces_uniqueid"] })), space = _a.space, domRect = _a.domRect, elementRef = _a.elementRef, resizeHandles = _a.resizeHandles;
    useEffectOnce(function () {
        space.element = elementRef.current;
    });
    var userClasses = className ? className.split(" ").map(function (c) { return c.trim(); }) : [];
    var outerClasses = __spreadArray(__spreadArray(__spreadArray(__spreadArray([], ["spaces-space", space.children.find(function (s) { return s.resizing; }) ? "spaces-resizing" : undefined], false), [space.type === Type.Fixed ? "spaces-fixedsize-layout" : undefined], false), [space.type === Type.ViewPort ? "spaces-fullpage-layout" : undefined], false), userClasses.map(function (c) { return "".concat(c, "-container"); }), true).filter(function (c) { return c; });
    var innerClasses = __spreadArray(__spreadArray([], ["spaces-space-inner"], false), userClasses, true);
    var innerStyle = style;
    if (space.handlePlacement === ResizeHandlePlacement.Inside) {
        innerStyle = __assign(__assign({}, style), {
            left: space.anchor === AnchorType.Right ? space.handleSize : undefined,
            right: space.anchor === AnchorType.Left ? space.handleSize : undefined,
            top: space.anchor === AnchorType.Bottom ? space.handleSize : undefined,
            bottom: space.anchor === AnchorType.Top ? space.handleSize : undefined,
        });
    }
    var centeredContent = applyCentering(children, props.centerContent);
    return (React.createElement(React.Fragment, null,
        resizeHandles.mouseHandles.map(function (handleProps) { return (handleRender === null || handleRender === void 0 ? void 0 : handleRender(handleProps)) || React.createElement("div", __assign({}, handleProps)); }),
        React.createElement(props.as || "div", __assign({
            id: space.id,
            ref: elementRef,
            className: outerClasses.join(" "),
        }, events), React.createElement("div", { className: innerClasses.join(" "), style: innerStyle },
            React.createElement(ParentContext.Provider, { value: space.id },
                React.createElement(LayerContext.Provider, { value: undefined },
                    React.createElement(DOMRectContext.Provider, { value: domRect }, centeredContent)))))));
};
//# sourceMappingURL=Space.js.map