import { __assign, __extends } from "tslib";
import { fireEvent } from "@testing-library/react";
var FakeMouseEvent = /** @class */ (function (_super) {
    __extends(FakeMouseEvent, _super);
    function FakeMouseEvent(type, values) {
        var _this = this;
        var pageX = values.pageX, pageY = values.pageY, offsetX = values.offsetX, offsetY = values.offsetY, x = values.x, y = values.y /*, ...mouseValues */;
        _this = _super.call(this, type, undefined) || this;
        Object.assign(_this, {
            offsetX: offsetX || 0,
            offsetY: offsetY || 0,
            pageX: pageX || 0,
            pageY: pageY || 0,
            x: x || 0,
            y: y || 0,
        });
        return _this;
    }
    return FakeMouseEvent;
}(MouseEvent));
export function getMouseEvent(type, values) {
    values = __assign({ bubbles: true, cancelable: true }, values);
    return new FakeMouseEvent(type, values);
}
var defaultDomRect = { x: 0, y: 0, width: 0, height: 0, bottom: 0, left: 0, right: 0, top: 0, toJSON: function () { return null; } };
export function drag(resizeElement, spaceElement, startRect, endRect, endX, endY) {
    spaceElement.getBoundingClientRect = jest.fn(function () { return (__assign(__assign({}, defaultDomRect), startRect)); });
    fireEvent.mouseDown(resizeElement, { clientX: 0, clientY: 0 });
    spaceElement.getBoundingClientRect = jest.fn(function () { return (__assign(__assign({}, defaultDomRect), endRect)); });
    fireEvent.mouseMove(resizeElement, { clientX: endX, clientY: endY });
    fireEvent.mouseUp(resizeElement, { clientX: endX, clientY: endY });
}
//# sourceMappingURL=TestUtils.js.map