import { __awaiter, __generator } from "tslib";
import * as React from "react";
import { render, cleanup } from "@testing-library/react";
import { Fixed } from "../../Fixed";
import "@testing-library/jest-dom/extend-expect";
import { commonPropsTests, commonPropTypesTest, hasProps } from "../Common";
afterEach(cleanup);
commonPropsTests("Fixed", React.createElement(Fixed, { height: 50 }), {
    position: "relative",
    left: "",
    top: "",
    right: "",
    bottom: "",
    width: "",
    height: "50px",
});
test("Fixed with width and height has correct styles", function () { return __awaiter(void 0, void 0, void 0, function () {
    var container, sut, style;
    return __generator(this, function (_a) {
        container = render(React.createElement(Fixed, { id: "test", width: 10, height: 20 })).container;
        sut = container.querySelector("#test");
        style = window.getComputedStyle(sut);
        expect(style.left).toBe("");
        expect(style.top).toBe("");
        expect(style.right).toBe("");
        expect(style.bottom).toBe("");
        expect(style.width).toBe("10px");
        expect(style.height).toBe("20px");
        return [2 /*return*/];
    });
}); });
commonPropTypesTest("Fixed", Fixed);
test("Fixed has correct prop types", function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        hasProps("Fixed", Fixed, ["width", "height"]);
        return [2 /*return*/];
    });
}); });
//# sourceMappingURL=Fixed.js.map